import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

public class JasmineSearchWindow extends JDialog
implements ActionListener
{
 public JPanel topPanel,buttonPanel,textPanel;
 public JButton searchButton, replaceButton,closeButton;
 public JTextField forField,withField;
 public JTextArea textArea;
 public Component parent;
 public int currentIndex;

 public JasmineSearchWindow(Component parent,JTextArea jta)
 {
  setSize(new Dimension(355,125));
  setLocation(parent.getLocation().x,parent.getLocation().y);
  setResizable(false);
  currentIndex=0;
  textArea=jta;
  setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
  setTitle("Search and Replace");
  JPanel labelPanel=new JPanel();
  labelPanel.setLayout(new FlowLayout());
  labelPanel.setPreferredSize(new Dimension(40,90));
  Dimension labelSize=new Dimension(90,17);
  JLabel forLabel=new JLabel("Seach For");
  forLabel.setPreferredSize(labelSize);
  JLabel withLabel=new JLabel("Replace With");
  withLabel.setPreferredSize(labelSize);
  labelPanel.add(forLabel);
  labelPanel.add(withLabel);
  JPanel fieldsPanel=new JPanel();
  fieldsPanel.setLayout(new FlowLayout());
  fieldsPanel.setPreferredSize(new Dimension(140,45));
  forField=new JTextField();
  forField.setPreferredSize(new Dimension(210,20));
  withField=new JTextField(); 
  withField.setPreferredSize(new Dimension(210,20));
  fieldsPanel.add(forField);
  fieldsPanel.add(withField);
  textPanel=new JPanel();
  textPanel.setLayout(new BoxLayout(textPanel,BoxLayout.X_AXIS));
  textPanel.add(labelPanel);
  textPanel.add(fieldsPanel);
  buttonPanel=new JPanel(new FlowLayout());
  buttonPanel.setBorder(new BevelBorder(BevelBorder.RAISED));
  Dimension buttonSize=new Dimension(100,25);
  buttonPanel.add(searchButton=new JButton("Search"));
  searchButton.setPreferredSize(buttonSize);
  searchButton.addActionListener(this);
  buttonPanel.add(replaceButton=new JButton("Replace"));
  replaceButton.setPreferredSize(buttonSize);
  replaceButton.addActionListener(this);
  buttonPanel.add(closeButton=new JButton("Close"));
  closeButton.setPreferredSize(buttonSize);
  closeButton.addActionListener(this);
  topPanel=new JPanel(new BorderLayout());
  topPanel.add(textPanel,BorderLayout.CENTER);
  topPanel.add(buttonPanel,BorderLayout.SOUTH);
  getContentPane().add(topPanel);
  setVisible(true);
  
 }
public void actionPerformed(ActionEvent e)
{
 if(e.getSource()==closeButton)
 dispose();
 else if(e.getSource()==replaceButton)
 {
   String theFile=textArea.getText();
   String f=forField.getText();
   String w=withField.getText();
   String temp1, temp2;
   temp1=theFile.substring(0,currentIndex);   
   temp2=theFile.substring(currentIndex+f.length(),theFile.length());
   textArea.setText(temp1+w+temp2);  
                      
  }
  else if(e.getSource()==searchButton)
  {
    if((textArea.getText().indexOf(forField.getText(),currentIndex))!=-1)
    {
      currentIndex=textArea.getText().indexOf(forField.getText(),currentIndex+1);
      textArea.setSelectionStart(currentIndex);
      textArea.setSelectionEnd(currentIndex+forField.getText().length());
     }
  }
      
}

} 