   import javax.swing.*;
   import javax.swing.event.*;
   import javax.swing.text.*;
   import javax.swing.border.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.io.*;
   import java.util.*;

   public class settingsWindow extends JDialog
   implements ActionListener, WindowListener
   { 
      private JPanel topPanel,buttonPanel;
      private JButton applyButton,cancelButton,brCompilerButton;
      private JTextField compilePathField,classPathField,smtpServerField;
      private JasmineIDE parent;
      private JCheckBox checkBox;
      public settingsWindow(JasmineIDE par)
      {
         parent=par;
         setTitle("JasmineIDE Settings");
         setModal(true);
         setResizable(false);
         setSize(new Dimension(450,225));
         Point p = new Point(parent.getLocation().x,parent.getLocation().y);
         setLocation(p.x+(parent.getSize().width/2)-225,
                    p.y+(parent.getSize().height/2)-100);
         compilePathField=new JTextField();
         compilePathField.setPreferredSize(new Dimension(200,20));
         classPathField=new JTextField();
         classPathField.setPreferredSize(new Dimension(200,20));
         smtpServerField=new JTextField();
         smtpServerField.setPreferredSize(new Dimension(200,20));
         JPanel labelPanel=new JPanel();
         labelPanel.setLayout(new BoxLayout(labelPanel,BoxLayout.Y_AXIS));
         labelPanel.setPreferredSize(new Dimension(110,100));
         Dimension labelSize=new Dimension(100,55);
         JLabel compLabel=new JLabel("JDK Directory");
         compLabel.setHorizontalAlignment(JLabel.RIGHT);
         compLabel.setPreferredSize(labelSize);
         labelPanel.add(compLabel);
         JLabel classLabel=new JLabel("Java Classpath");
         classLabel.setHorizontalAlignment(JLabel.RIGHT);
         classLabel.setPreferredSize(labelSize);
         labelPanel.add(classLabel);
         JLabel smtpLabel=new JLabel("Mail Server Out");
         smtpLabel.setHorizontalAlignment(JLabel.RIGHT);
         smtpLabel.setPreferredSize(labelSize);
         labelPanel.add(smtpLabel);
         JPanel textPanel=new JPanel();
         Dimension buttonSize =new Dimension(90,25);
         //textPanel.setPreferredSize(new Dimension(320,100));
         textPanel.setLayout(new BoxLayout(textPanel,BoxLayout.Y_AXIS));
         JPanel compilerPanel = new JPanel(new FlowLayout());
         compilerPanel.add(compilePathField);
         compilerPanel.add(brCompilerButton=new JButton("Browse"));
         brCompilerButton.addActionListener(this);
         brCompilerButton.setPreferredSize(buttonSize);
         textPanel.add(compilerPanel);
         JPanel classPanel=new JPanel(new FlowLayout());
         classPanel.add(classPathField);
         JButton blankButton2=new JButton("");
         blankButton2.setBorder(null);
         blankButton2.setEnabled(false);
         blankButton2.setPreferredSize(buttonSize);
         classPanel.add(blankButton2);
         textPanel.add(classPanel);
         JPanel serverPanel=new JPanel(new FlowLayout());
         serverPanel.add(smtpServerField);
         JButton blankButton=new JButton("");
         blankButton.setBorder(null);
         blankButton.setEnabled(false);
         blankButton.setPreferredSize(buttonSize);
         serverPanel.add(blankButton);
         textPanel.add(serverPanel);
         JPanel mainPanel=new JPanel(new FlowLayout());
         mainPanel.setBorder(new EtchedBorder());
         mainPanel.add(labelPanel);
         mainPanel.add(textPanel);
         applyButton=new JButton("Apply");
         applyButton.addActionListener(this);
         cancelButton=new JButton("Close");
         cancelButton.addActionListener(this);
         buttonPanel=new JPanel(new FlowLayout());
         buttonPanel.setBorder(new BevelBorder(BevelBorder.RAISED));
         buttonPanel.add(applyButton);
         buttonPanel.add(cancelButton);
         JPanel autoUpdatePanel = new JPanel(new FlowLayout());
         autoUpdatePanel.setBorder(new BevelBorder(BevelBorder.LOWERED));
         checkBox = new JCheckBox("Classes and methods should update on linefeed.",par.autoUpdate.booleanValue());
         if(par.autoUpdate.booleanValue())
          System.out.println(true);
         else 
           System.out.println(false);
         autoUpdatePanel.add(checkBox);
         autoUpdatePanel.setPreferredSize(new Dimension(getSize().width,40));
         topPanel=new JPanel(new BorderLayout());
         topPanel.add(mainPanel,BorderLayout.NORTH);
         topPanel.add(autoUpdatePanel,BorderLayout.CENTER);
         topPanel.add(buttonPanel,BorderLayout.SOUTH);
         getContentPane().add(topPanel);
         try
         {
            BufferedReader br = new BufferedReader(new FileReader("./settings.ini"));
            compilePathField.setText(br.readLine());
            classPathField.setText(br.readLine());
            smtpServerField.setText(br.readLine());
         }
            catch(IOException ioexc)
            {System.out.println(ioexc);}
         setVisible(true);
      
      }
      public void actionPerformed(ActionEvent e)
      {
         if(e.getSource()==cancelButton)
            dispose();
         if(e.getSource()==applyButton)
         {
            try
            {
               BufferedWriter bw =new BufferedWriter(new FileWriter("./settings.ini",false));
               bw.write(compilePathField.getText()+"\n");
               parent.javaPath=compilePathField.getText();
               bw.write(classPathField.getText()+"\n");
               bw.write(smtpServerField.getText()+"\n");
               if(checkBox.isSelected())
               parent.autoUpdate=parent.autoUpdate.valueOf("true");
               else
               parent.autoUpdate=parent.autoUpdate.valueOf("false");               
               bw.close();
            }
               catch(IOException ioe)
               {System.out.println(ioe);}
         }
         if(e.getSource()==brCompilerButton)
         {
            JFileChooser file_dialog=new JFileChooser();
            file_dialog.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);	
            int returnValue = file_dialog.showDialog(this, "Set JDK Path");
            if(returnValue == 0)
            {
               File file = file_dialog.getSelectedFile();
               compilePathField.setText(file.toString()+System.getProperty("file.separator"));           
            }
         }
      
      }
   
      public void windowClosing( WindowEvent event ) {
         dispose(); }
      public void windowOpened( WindowEvent event ) {
      }
      public void windowIconified( WindowEvent event ) {
      }
      public void windowDeiconified( WindowEvent event ) {
      }
      public void windowClosed( WindowEvent event ) {
      }
      public void windowActivated( WindowEvent event ) {
      }
      public void windowDeactivated( WindowEvent event ) {
      }
   
   }
